library ieee;
use ieee.std_logic_1164.all;

package my_type is
   type frequency_type is (freq_1_MHz, freq_2_MHz, freq_5_MHz, freq_10_MHz, freq_25_MHz);
end;

library ieee;
use ieee.std_logic_1164.all;
use work.my_type.all;


entity gen_horloge is

   generic(
	   FREQ : frequency_type := freq_10_MHz
	);
	
	port(
		clock : in std_logic;
		pulse : out std_logic
	);
end;

architecture behave of gen_horloge is

   type frequency_values_type is array (frequency_type) of natural;

begin
	process
	
		constant FREQ_VALUES : frequency_values_type := (1, 2, 5, 10, 25);
	   constant COUNT_MAX : natural := 50/FREQ_VALUES(FREQ) - 1;
		constant HALF_PERIOD : natural := integer(COUNT_MAX / 2) +1;
		variable count : natural range 0 to COUNT_MAX;
		
	begin
	   wait until rising_edge(clock);
		if count < COUNT_MAX then
			if count < HALF_PERIOD  then
			   pulse <= '0';
			else 
			   pulse <= '1';
			end if;
			
			count := count+1;
			
		else 
			count := 0;
			pulse <= '1';
		end if;
	end process;
end;