library ieee;
use ieee.std_logic_1164.all;

entity oversampling is 
  port(
    clock_sample : in std_logic;
	 symbol : in integer range -1 to 1;
	 symbol_oversampled : out integer range -1 to 1 :=0
  );
 end;
 
architecture behave of oversampling is
  begin
  process (clock_sample)
  constant OSR : natural := 4;
  variable padding_counter : natural range 0 to OSR-1 :=0;
	begin
	  if falling_edge(clock_sample) then
	  
	    case padding_counter is
		   when 0 => symbol_oversampled <= symbol; 
			when others => symbol_oversampled <= 0;
		 end case; 

       if padding_counter < OSR- 1 then
			padding_counter := padding_counter + 1;
		 else 
			padding_counter := 0;
		 end if;
				 
	  end if;
end process;
end;