library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity serial_2_parallel is 
	port (
		serial_bit, clock : in std_logic;
		parallel_bit : out unsigned(1 downto 0)
	);
end;

architecture behave of serial_2_parallel is
	signal register_state : unsigned (1 downto 0);
begin
	
	process(clock)	
		variable TWO_NEW_BITS_IN : boolean := false;		
	begin
	
		if rising_edge(clock) then
		
			register_state(0) <= serial_bit;
			
			register_state(1) <= register_state(0);
			
			if TWO_NEW_BITS_IN then			
				parallel_bit <= register_state;
				TWO_NEW_BITS_IN := false;			
			else							
				TWO_NEW_BITS_IN := true;
				
			end if;
		end if;
	end process;		
end;